<?php

/**
 * NetBase PHP API SDK
 * @author frankwwj - 89558889@gmail.com
 * @license MIT - https://opensource.org/licenses/MIT
 */
require_once __DIR__.'/NetBaseApi.php';

class TYIotApi extends NetBaseApi
{
    public function __construct($key = NULL, $base_url = NULL)
    {
        //$this->_base_url = 'https://www.xmiot.top:8109';
		$this->_base_url = 'https://localhost:8109';
		//$this->_base_url = 'https://120.79.163.84:8109';
		$this->_key = NULL;
		
		/*if (!empty($key)) {
			$this->_key = $key;
		}
        if (!empty($base_url)) {
            $this->_base_url = $base_url;
        }*/
    }
	
	private  function _convAry2Str($arya1)
	{
		$ret = "";
		foreach($arya1 as $x=>$x_value)
		{
			$t1 = dechex($x_value);
			if (strlen($t1) == 1)
				$t1 = '0'.$t1;
			$ret .= $t1;
		}
		return $ret;
	}
	
	public function getcmddata($mac_addr,$cmd,$value1 = 0,$reserve = 0)
	{
		$byteRead = array();
		array_push($byteRead,0x68,0x60 + ($mac_addr % 10),0x10);
		$k1 = 3;
		/*
		  $byteRead[1] := 0x03;
		  $byteRead[2] := 0x18;
		  k1:= 3;
		  tempDWord := $CC00CC00;
		  CopyMemory(@byteRead[k1],@tempDWord,4);
		  k1:=k1+4;
		  tempDWord := $00000000;
		  CopyMemory(@byteRead[k1],@tempDWord,4);
		  k1:=k1+4;
		*/
		$alllenpos = $k1;
		array_push($byteRead,0x00,0x00);
		$k1 += 2;
		switch ($cmd)
		{
			case 2:
				array_push($byteRead,$cmd);
				array_push($byteRead,0x00,0x00);
				array_push($byteRead,0xFF);
				array_push($byteRead,0x00,0x00,0x00,$value1);
				$k1 += 8;
				break;
			case 8:
				array_push($byteRead,$cmd);
				array_push($byteRead,0x00,0x00);
				array_push($byteRead,0xFF);
				array_push($byteRead,0x00,0x00,0x00,$value1);
				$k1 += 8;
				break;
			case 16:
				array_push($byteRead,$cmd);
				array_push($byteRead,0x00,0x00);
				$k1 += 3;
				break;
			case 95:
				array_push($byteRead,$cmd);
				array_push($byteRead,0x00,0x00);
				array_push($byteRead,0x01);
				array_push($byteRead,0x00,0x00,0x00,$value1);
				$k1 += 8;
				break;
			default:
				return "";
		}
		$byteRead[$alllenpos+3] = ($k1-$alllenpos-5);
		$byteRead[$alllenpos] =  ($k1-$alllenpos-2) % 256;
		$byteRead[$alllenpos+1] = (($k1-$alllenpos-2) / 256);
		$sum_check = 0;
		for ($i = $alllenpos+2; $i <= $k1-1; $i++)
			$sum_check = $sum_check + $byteRead[$i];
		$sum_check = 255 - ($sum_check % 256);
		array_push($byteRead,$sum_check);
		array_push($byteRead,0x16);
		return $this->_convAry2Str($byteRead);
	}
	
	public function SendCfgByDevice($cmdid,$urlparam,$strdeviceid,$strcfg)
    {
		//$api = "WEB01_MB/NbiotRecvTest";
		$api = "TEST/NbiotRecvPost";
		$jsondata = array(
			'deviceId'=>$strdeviceid,
			'command'=>array(
				'serviceId'=>"0",
				'method'=>"Msg",
				'paras'=>array('sendMsg'=>$strcfg)
			)
		);
		
		$httpheaders = array(
			"CMDID: {$cmdid}","urlparams:'{$urlparam}'", "IP:''", "Port:0", "secret:''",
			"app_key:'nFZxv74UnqkO1FCwVW5rZ0AtfC4a'","Authorization:''"
		);
		//return json_encode($httpheaders);//json_encode($jsondata).
		return $this->_call_https($api,'POST',$jsondata,$httpheaders);
		//return $this->_call_https($api,'GET');
	}
	
	public function SendCmdByDevice($strdeviceid,$cmd,$value1,$reserve=0)
	{
		$tmpstr = $this->getcmddata($strdeviceid,$cmd,$value1,$reserve);
		if ($tmpstr == "")
			return "";
		else
			return $this->SendCfgByDevice(20,"iocm/app/cmd/v1.4.0/deviceCommands",$strdeviceid,$tmpstr);
	}
}